libmpdclient: mpd/message.h File Reference

libmpdclient 2.13

Functions
message.h File Reference

MPD client library. More...

Go to the source code of this file.

## Functions
mpd_malloc struct mpd_message * | mpd_message_begin (const struct mpd_pair *pair)
bool | mpd_message_feed (struct mpd_message *output, const struct mpd_pair *pair)
void | mpd_message_free (struct mpd_message *message)
mpd_pure const char * | mpd_message_get_channel (const struct mpd_message *message)
mpd_pure const char * | mpd_message_get_text (const struct mpd_message *message)
bool | mpd_send_subscribe (struct mpd_connection *connection, const char *channel)
bool | mpd_run_subscribe (struct mpd_connection *connection, const char *channel)
bool | mpd_send_unsubscribe (struct mpd_connection *connection, const char *channel)
bool | mpd_run_unsubscribe (struct mpd_connection *connection, const char *channel)
bool | mpd_send_send_message (struct mpd_connection *connection, const char *channel, const char *text)
bool | mpd_run_send_message (struct mpd_connection *connection, const char *channel, const char *text)
bool | mpd_send_read_messages (struct mpd_connection *connection)
mpd_malloc struct mpd_message * | mpd_recv_message (struct mpd_connection *connection)
bool | mpd_send_channels (struct mpd_connection *connection)
static mpd_malloc struct mpd_pair * | mpd_recv_channel_pair (struct mpd_connection *connection)

## Detailed Description

MPD client library.

Do not include this header directly. Use mpd/client.h instead.

Definition in file message.h.

## Function Documentation

## ◆ mpd_message_begin()

mpd_malloc struct mpd_message* mpd_message_begin | ( | const struct mpd_pair * | pair | ) |

Begins parsing a new message.

Parameters

  pair | the first pair in this message (name must be "channel")

Returns
  the new mpd_entity object, or NULL on error (out of memory, or pair name is not "channel")

Since
  libmpdclient 2.5

## ◆ mpd_message_feed()

bool mpd_message_feed | ( | struct mpd_message * | output,
|  | const struct mpd_pair * | pair
| ) |  |

Parses the pair, adding its information to the specified mpd_message object.

Returns
  true if the pair was parsed and added to the message (or if the pair was not understood and ignored), false if this pair is the beginning of the next message

Since
  libmpdclient 2.5

## ◆ mpd_message_free()

void mpd_message_free | ( | struct mpd_message * | message | ) |

Frees a mpd_message object.

Since
  libmpdclient 2.5

## ◆ mpd_message_get_channel()

mpd_pure const char* mpd_message_get_channel | ( | const struct mpd_message * | message | ) |

Returns the channel name.

Since
  libmpdclient 2.5

## ◆ mpd_message_get_text()

mpd_pure const char* mpd_message_get_text | ( | const struct mpd_message * | message | ) |

Returns the message text.

Since
  libmpdclient 2.5

## ◆ mpd_send_subscribe()

bool mpd_send_subscribe | ( | struct mpd_connection * | connection,
|  | const char * | channel
| ) |  |

Sends the "subscribe" command: subscribe to a message channel.

Parameters

  connection | the connection to MPD
  channel | the channel name

Returns
  true on success

Since
  libmpdclient 2.5

## ◆ mpd_run_subscribe()

bool mpd_run_subscribe | ( | struct mpd_connection * | connection,
|  | const char * | channel
| ) |  |

Shortcut for mpd_send_subscribe() and mpd_response_finish().

Parameters

  connection | the connection to MPD
  channel | the channel name

Returns
  true on success

Since
  libmpdclient 2.5

## ◆ mpd_send_unsubscribe()

bool mpd_send_unsubscribe | ( | struct mpd_connection * | connection,
|  | const char * | channel
| ) |  |

Sends the "unsubscribe" command: unsubscribe from a message channel.

Parameters

  connection | the connection to MPD
  channel | the channel name

Returns
  true on success

Since
  libmpdclient 2.5

## ◆ mpd_run_unsubscribe()

bool mpd_run_unsubscribe | ( | struct mpd_connection * | connection,
|  | const char * | channel
| ) |  |

Shortcut for mpd_send_unsubscribe() and mpd_response_finish().

Parameters

  connection | the connection to MPD
  channel | the channel name

Returns
  true on success

Since
  libmpdclient 2.5

## ◆ mpd_send_send_message()

bool mpd_send_send_message | ( | struct mpd_connection * | connection,
|  | const char * | channel,
|  | const char * | text
| ) |  |

Sends the "sendmessage" command: send a message to a channel.

Parameters

  connection | the connection to MPD
  channel | the channel name
  text | the message text

Returns
  true on success

Since
  libmpdclient 2.5

## ◆ mpd_run_send_message()

bool mpd_run_send_message | ( | struct mpd_connection * | connection,
|  | const char * | channel,
|  | const char * | text
| ) |  |

Shortcut for mpd_send_send_message() and mpd_response_finish().

Parameters

  connection | the connection to MPD
  channel | the channel name
  text | the message text

Returns
  true on success

Since
  libmpdclient 2.5

## ◆ mpd_send_read_messages()

bool mpd_send_read_messages | ( | struct mpd_connection * | connection | ) |

Sends the "readmessages" command: send a message to a channel.

Parameters

  connection | the connection to MPD

Returns
  true on success

Since
  libmpdclient 2.5

## ◆ mpd_recv_message()

mpd_malloc struct mpd_message* mpd_recv_message | ( | struct mpd_connection * | connection | ) |

Reads the next mpd_message from the MPD response. Free the return value with mpd_message_free().

Returns
  a mpd_message object on success, NULL on error or end-of-response

Since
  libmpdclient 2.5

## ◆ mpd_send_channels()

bool mpd_send_channels | ( | struct mpd_connection * | connection | ) |

Sends the "channels" command: get a list of all channels.

Parameters

  connection | the connection to MPD

Returns
  true on success

Since
  libmpdclient 2.5

## ◆ mpd_recv_channel_pair()

static mpd_malloc struct mpd_pair* mpd_recv_channel_pair | ( | struct mpd_connection * | connection | ) |
| static

Receives the next channel name. Call this in a loop after mpd_send_channels().

Free the return value with mpd_return_pair().

Parameters

  connection | a mpd_connection

Returns
  a "channel" pair, or NULL on error or if the end of the response is reached

Since
  libmpdclient 2.5

Definition at line 232 of file message.h.